////////////////////////////////////////////////////////////////////////////
//
// ڐGJ[h XL~OA[.
//
// Copyright by rubidesu 2018
// http://www.gatelink.co.jp/hw/
//
////////////////////////////////////////////////////////////////////////////

#include <12f683.h>

//}CR̃q[Yݒ.
#fuses INTRC_IO, NOWDT, PUT, NOPROTECT, NOMCLR, NOBROWNOUT

//fBCp̃NbNݒ.
#use delay(clock=250000)

#rom 0x7FF = {0x3400}

#use RS232(BAUD=1200, XMIT=PIN_A5)

//^`.
typedef unsigned int1	BIT;
typedef unsigned int16	WORD;
typedef unsigned int32	DWORD;

//|[gÃrbg`.
struct tagPORTA{
	short bit0;
	short bit1;
	short bit2;
	short bit3;
	short bit4;
	short bit5;
	short bit6;
	short bit7;
}PORTA;
#byte PORTA = 5

//High/Low̒`.
#define HIGH 1
#define LOW  0

//|[g`.
#define LOOP_COIL	PORTA.bit4	//[vRC̓|[g.

#define BEEP_DELAY_TIME		100	//r[v炷(10msecP).

//PWM̎(Clock=250KHz, PWM=4.17KHz).
#define PWM_DUTY_MAX		15
#define PWM_DUTY_HALF		8	//Duty=50%.
#define PWM_DUTY_OFF		0

//PWM֌W̃WX^.
#byte CCPR1L = 0x13
#byte CCP1CON = 0x15

////////////////////////////////////////////////////////////////////////////
// |[gω荞.
// X[v̕Â.
////////////////////////////////////////////////////////////////////////////
#INT_RA
void int_ra_isr(void)
{
	BYTE bDat;
	bDat = PORTA;
}

////////////////////////////////////////////////////////////////////////////
// PWM̒lZbg.
////////////////////////////////////////////////////////////////////////////
void set_pwm_value(WORD wVal)
{
	if(wVal > PWM_DUTY_MAX){
		wVal = PWM_DUTY_MAX;
	}

	CCPR1L = (BYTE)wVal;
}

////////////////////////////////////////////////////////////////////////////
// C.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
main()
{
	WORD wLoopCnt = 0;
	BIT  bNowState = 0;
	BIT  bLastState = 0;

	set_tris_a(0b00011000);

	setup_oscillator(OSC_250KHZ);

	setup_comparator(NC_NC_NC_NC);
	setup_adc(adc_off);
	setup_adc_ports(NO_ANALOGS);

	//PWM̐ݒ.
	CCP1CON = CCP_PWM;
	setup_timer_2(T2_DIV_BY_1, PWM_DUTY_MAX - 1, 1);

	set_pwm_value(PWM_DUTY_OFF);

	enable_interrupts(INT_RA4);	
	enable_interrupts(GLOBAL);	

	putc('P');

	while(1){
		putc('S');

		enable_interrupts(INT_RA4);

		sleep();
		#asm nop #endasm

		disable_interrupts(INT_RA4);

		putc('W');

		wLoopCnt = 0;
		while(1){
			bNowState = LOOP_COIL;
			if(bNowState == 1){
				set_pwm_value(PWM_DUTY_HALF);

				if(bLastState == 0){
					putc('1');
				}

				wLoopCnt = 0;
			}
			else{
				if(bLastState == 1){
					putc('0');
				}

				wLoopCnt++;
			}
			bLastState = bNowState;

			if(wLoopCnt > BEEP_DELAY_TIME){
				set_pwm_value(PWM_DUTY_OFF);
				break;
			}

			delay_ms(10);
		}
	}
}

